using SurgeEngine.Actor;
using SurgeEngine.Player;
using SurgeEngine.Collisions.CollisionBox;
using SurgeEngine.Collisions.CollisionBall;

using SurgeEngine.Prefs;


object "ActivityDebugger" is "entity", "awake"
{
    state "main"
    {
        player = Player.active;
        Console.print(player.activity);
    }
}


object "ShieldBox" is "entity"
{
    actor = Actor("ShieldBox");
    shieldCollider = CollisionBox(32,32);

    state "main"
    {
        player = Player.active;
        if(player.attacking) {
            if(player.collider.collidesWith(shieldCollider)) {
                if(player.midair)
                    player.bounce(actor);
                player.shield = "fire";
                destroy();
            }
        }
    }
}

object "CollisionTest" is "entity"
{
    actor = Actor("CollisionTest");
    myCollider = CollisionBall(25); // ball with radius = 25px

    // The player has a built-in collider
    // Let's make it visible
    state "main"
    {
        player = Player.active;
        player.collider.visible = true;
        myCollider.visible = true;
    }

    // Detect collisions between a collider that is a child
    // of this object and any other collider in the game
    fun onCollision(collider)
    {
        // A collision has occurred.
        if(collider.entity.hasTag("player")) {
            // Collided with a player?
            player = collider.entity;
            Console.print("Touched " + player.name);
        }
        else
            Console.print("Collided with something else.");
    }
}
